// Generated with Blu Age version 201912

package planets.dumpdata.service.impl;

import com.netfective.bluage.gapwalk.datasimplifier.utils.NumberUtils;
import com.netfective.bluage.gapwalk.rt.call.ExecutionController;
import java.util.*;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Service;
import planets.dumpdata.business.context.DumpdataContext;
import planets.dumpdata.service.DumpdataProcess;

/**
 * Class DumpdataProcessImpl
 * 
 * Defines application services for DumpdataProcess
 * @see DumpdataProcess
 */
@Service("planets.dumpdata.service.DumpdataProcess")
public class DumpdataProcessImpl implements DumpdataProcess {

	/**
	 * The logger.
	 */
	private static final Logger LOGGER = LoggerFactory.getLogger(DumpdataProcessImpl.class);


	/**
	 * Process operation main.
	 * 
	 * PROGRAM-ID.dumpdata.
	 * 
	 * @param ctx 
	 * @param ctrl 
	 */
	@Override
	public void main(final DumpdataContext ctx, final ExecutionController ctrl) {
		if (LOGGER.isInfoEnabled()) LOGGER.info("Planets data:");
		ctx.getCounters().setIdx(1);
		while (NumberUtils.le(ctx.getCounters().getIdxReference(), 8)) {
			if (LOGGER.isInfoEnabled()) LOGGER.info("{}{}{}" , "* " , ctx.getPlanetsData().getItemFromName(ctx.getCounters().getIdx() - 1).trim() , ":");
			if (LOGGER.isInfoEnabled()) LOGGER.info("{}{}{}" , "  - MASS: " , ctx.getPlanetsData().getItemFromMassReference(ctx.getCounters().getIdx() - 1).getValue(String.class) , " * 10^24kg");
			if (LOGGER.isInfoEnabled()) LOGGER.info("{}{}{}" , "  - DIAMETER: " , ctx.getPlanetsData().getItemFromDiameterReference(ctx.getCounters().getIdx() - 1).getValue(String.class) , "km");
			if (LOGGER.isInfoEnabled()) LOGGER.info("{}{}{}" , "  - DENSITY: " , ctx.getPlanetsData().getItemFromDensityReference(ctx.getCounters().getIdx() - 1).getValue(String.class) , "kg/m3");
			if (LOGGER.isInfoEnabled()) LOGGER.info("{}{}{}" , "  - LENGTH OF DAY: " , ctx.getPlanetsData().getItemFromDayLengthReference(ctx.getCounters().getIdx() - 1).getValue(String.class) , "h");
			if (LOGGER.isInfoEnabled()) LOGGER.info("{}{}{}" , "  - DISTANCE TO SUN: " , ctx.getPlanetsData().getItemFromSunDistanceReference(ctx.getCounters().getIdx() - 1).getValue(String.class) , " * 10^6km");
			if (LOGGER.isInfoEnabled()) LOGGER.info("{}{}{}" , "  - ORBITAL PERIOD: " , ctx.getPlanetsData().getItemFromOrbitalPeriodReference(ctx.getCounters().getIdx() - 1).getValue(String.class) , " days");
			if (LOGGER.isInfoEnabled()) LOGGER.info("{}{}{}" , "  - MEAN TEMPERATURE: " , ctx.getPlanetsData().getItemFromMeanTemperatureReference(ctx.getCounters().getIdx() - 1).getValue(String.class) , "C");
			if (LOGGER.isInfoEnabled()) LOGGER.info("{}{}" , "  - NUMBER OF MOONS: " , ctx.getPlanetsData().getItemFromMoonsNbReference(ctx.getCounters().getIdx() - 1).getValue(String.class));
			if (LOGGER.isInfoEnabled()) LOGGER.info("{}{}" , "  - HAS A RING SYSTEM: " , ctx.getPlanetsData().getItemFromHasRings(ctx.getCounters().getIdx() - 1));
			ctx.getCounters().setIdx(ctx.getCounters().getIdx() + 1);
		}
		if (ctx.isMainProgram()) {
			ctrl.stopRunUnit();
		}
	}

}
