// Import
import com.netfective.bluage.gapwalk.rt.provider.ScriptRegistry
import com.netfective.bluage.gapwalk.rt.call.MainProgramRunner
import com.netfective.bluage.gapwalk.io.support.FileConfigurationUtils
import com.netfective.bluage.gapwalk.rt.job.support.DefaultJobContext
import com.netfective.bluage.gapwalk.rt.utils.GroovyUtils
// Variables
mpr = applicationContext.getBean("com.netfective.bluage.gapwalk.rt.call.ExecutionController", MainProgramRunner.class)
Map params = ["MapTransfo":mapTransfo]
// Execute job with utility functions
def shell = new GroovyShell().parse(ScriptRegistry.getScript("functions"))
//*********************************************************************
//*                             JOB                                   *
//*********************************************************************
shell.with {
   def jobName = "LOADER"
   displayStartJob(jobName)
   Map programResults = [:]
   def lastProgramResult
   //
   //
   //******************************************************************
   //
   lastProgramResult = stepSTEP0001(shell, params, programResults)
   //
   lastProgramResult = stepSTEP0002(shell, params, programResults)
   //
   lastProgramResult = stepSTEP0003(shell, params, programResults)
   displayEndJob(jobName)
}
//*********************************************************************
//*                            STEPS                                  *
//*********************************************************************
// STEP STEP0001 - PGM - LDCUST***************************************************
def stepSTEP0001(Object shell, Map params, Map programResults){
   shell.with {
       return execStep("STEP0001", programResults, {
         mpr
            .withFileConfigurations(new FileConfigurationUtils()
               .bluesam("CUSTMAS")
               .dataset("CUSTMAS")
               .build()
               .getFileConfigurations())
            .withParameters(params)
            .runProgram("LDCUST")
         })
      }
   }
// STEP STEP0002 - PGM - LDPROD***************************************************
def stepSTEP0002(Object shell, Map params, Map programResults){
   shell.with {
       return execStep("STEP0002", programResults, {
         mpr
            .withFileConfigurations(new FileConfigurationUtils()
               .bluesam("PRODUCT")
               .dataset("PRODUCT")
               .build()
               .getFileConfigurations())
            .withParameters(params)
            .runProgram("LDPROD")
         })
      }
   }
// STEP STEP0003 - PGM - LDINV****************************************************
def stepSTEP0003(Object shell, Map params, Map programResults){
   shell.with {
       return execStep("STEP0003", programResults, {
         mpr
            .withFileConfigurations(new FileConfigurationUtils()
               .bluesam("INVOICE")
               .dataset("INVOICE")
               .build()
               .bluesam("INVCTL")
               .dataset("INVCTL")
               .build()
               .getFileConfigurations())
            .withParameters(params)
            .runProgram("LDINV")
         })
      }
   }
