// Import
import com.netfective.bluage.gapwalk.rt.provider.ScriptRegistry
import com.netfective.bluage.gapwalk.rt.call.MainProgramRunner
import com.netfective.bluage.gapwalk.io.support.FileConfigurationUtils
import com.netfective.bluage.gapwalk.rt.job.support.DefaultJobContext
import com.netfective.bluage.gapwalk.rt.utils.GroovyUtils
// Variables
mpr = applicationContext.getBean("com.netfective.bluage.gapwalk.rt.call.ExecutionController", MainProgramRunner.class)
Map params = ["MapTransfo":mapTransfo]
// Execute job with utility functions
def shell = new GroovyShell().parse(ScriptRegistry.getScript("functions"))
//*********************************************************************
//*                             JOB                                   *
//*********************************************************************
shell.with {
   def jobName = "PRINTER"
   displayStartJob(jobName)
   Map programResults = [:]
   def lastProgramResult
   //
   //
   //******************************************************************
   //
   lastProgramResult = stepSTEP0001(shell, params, programResults)
   displayEndJob(jobName)
}
//*********************************************************************
//*                            STEPS                                  *
//*********************************************************************
// STEP STEP0001 - PGM - PRINTINV*************************************************
def stepSTEP0001(Object shell, Map params, Map programResults){
   shell.with {
       return execStep("STEP0001", programResults, {
         mpr
            .withFileConfigurations(new FileConfigurationUtils()
               .bluesam("REPINV")
               .dataset("REPINV")
               .build()
               .bluesam("INVOICE")
               .dataset("INVOICE")
               .build()
               .getFileConfigurations())
            .withParameters(params)
            .runProgram("PRINTINV")
         })
      }
   }
