import { Component, ComponentFactoryResolver, SystemJsNgModuleLoader, Compiler } from '@angular/core';
import { ActivatedRoute } from '@angular/router';
import * as $ from 'jquery';

import 'rxjs/add/operator/switchMap';

import { TransactionService } from './term/transaction.service';
import { TermService } from './term/term.service';
import { TestingService } from './term/testing.service';
import { mapComponents } from './maps/mapComponents';
import { ModalService } from './modal.service';
import { AbstTermComponent } from './abs-term.component';
import { AppService } from './app.service';

// Component injection imports

@Component({
    moduleId: module.id,
    selector: 'term',
    templateUrl: './term.component.html'
})

export class TermComponent extends AbstTermComponent {

    constructor(
        modalService: ModalService,
        transactionService: TransactionService,
        route: ActivatedRoute,
        loader: SystemJsNgModuleLoader,
        compiler: Compiler,
        service: TermService,
        componentFactoryResolver: ComponentFactoryResolver,
        appService: AppService,
        testingService: TestingService
    ) {
        super(modalService, transactionService, route, loader, compiler, service, componentFactoryResolver, appService, testingService);
    }

    getMapComponent(mapName: string) {
        return mapComponents[mapName];
    }

    getIdAnchor(): any {
        return $("#" + "rd_col01_l1");
    }

    public ngAfterViewChecked(): void {
        if (!this.modalService.containModal()) {
            super.ngAfterViewChecked();
        }
    }

    decodeFieldsSubComponent(): boolean {
        return false;
    }

    onKeyDownListener(e: KeyboardEvent) {

        // Disable listener if modals are displayed
        if (!this.modalService.containModal()) {
            super.onKeyDownListener(e);
        }
    }
}
