import { Attributes } from './message';

/**
 * Represents a data for dynamic fields.
 */
export class Data {
    /* FIELDS ============================================================== */
    public initialValue: string;
    public forceModified: boolean;
    public consultMode: boolean;

    /* CONSTRUCTORS ======================================================== */
    constructor(
        public value?: string,
        public legacyName?: string,
        public attributes?: Attributes,
        public initialCursor?: boolean
    ) {
        this.initialValue = value;
        this.forceModified = attributes && attributes.forceModified;
        this.consultMode = false;
    }
}

/**
 * Represents a group of data for update fields in maps.
 */
export class Token {
    /* FIELDS ============================================================== */
    public modal: string;

    /* CONSTRUCTORS ======================================================== */
    constructor( public children: TokenField[] ) {}
}

/**
 * Represents an update operation on field in map with data.
 */
export class TokenField {
    /* CONSTRUCTORS ======================================================== */
    constructor(
        public map: string,
        public field: string,
        public data: string,
    ) {}
}